''' <summary>
''' Classe de gestion d'un script
''' </summary>
''' <remarks></remarks>
Friend NotInheritable Class ClsScript
    Implements IRunnable

    ''' <summary>
    ''' Nom du script
    ''' </summary>
    ''' <remarks></remarks>
    Private mName As String
    ''' <summary>
    ''' Catgorie
    ''' </summary>
    ''' <remarks></remarks>
    Private mCategory As String
    ''' <summary>
    ''' Code du script
    ''' </summary>
    ''' <remarks></remarks>
    Private mRun As String = ""
    ''' <summary>
    ''' Raccourcis du script
    ''' </summary>
    ''' <remarks></remarks>
    Private mShortCut As String

    ''' <summary>
    ''' Constructeur
    ''' </summary>
    ''' <param name="pName">Nom</param>
    ''' <param name="pCategory">Catgorie</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal pName As String, ByVal pCategory As String, ByVal pShort As String)
        mName = pName
        mCategory = pCategory
        mShortCut = pShort.ToUpper
    End Sub

    ''' <summary>
    ''' Ajoute un programme
    ''' </summary>
    ''' <param name="pProgram">Programme</param>
    ''' <remarks></remarks>
    Public Sub Add(ByVal pProgram As IRunnable)
        mRun += vbCrLf + pProgram.Run
    End Sub

    ''' <summary>
    ''' Retourne la catgorie
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Category() As String Implements IRunnable.Category
        Get
            Return mCategory
        End Get
    End Property
    ''' <summary>
    ''' Retourne le nom
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Name() As String Implements IRunnable.Name
        Get
            Return mName
        End Get
    End Property
    ''' <summary>
    ''' Retourne le code
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function Run() As String Implements IRunnable.Run
        Return mRun
    End Function
    ''' <summary>
    ''' Retourne le raccourcis du script
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ShortCut() As String Implements IRunnable.ShortCut
        Get
            Return mShortCut
        End Get
    End Property
End Class
